//+------------------------------------------------------------------+
//|                                       Heiken Ashi zone trade.mq4 |
//+------------------------------------------------------------------+
#property copyright "http://www.forex-tsd.com"
#property link      "http://www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 RoyalBlue
#property indicator_color2 Red
#property indicator_color3 Silver
#property indicator_color4 DimGray
#property indicator_color5 RoyalBlue
#property indicator_color6 Red
#property indicator_color7 Silver
#property indicator_color8 DimGray

#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 3
#property indicator_width5 1
#property indicator_width6 1
#property indicator_width7 1
#property indicator_width8 1

//
//
//
//
//

extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];
double trend[];


//+------------------------------------------------------------------+
//|                                                                  |
//|------------------------------------------------------------------|
//
//
//
//
//

int init()
{
   SetIndexBuffer(0, ExtMapBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexEmptyValue(0,0);
   SetIndexBuffer(1, ExtMapBuffer2); SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexEmptyValue(1,0);
   SetIndexBuffer(2, ExtMapBuffer3); SetIndexStyle(2,DRAW_HISTOGRAM); SetIndexEmptyValue(2,0);
   SetIndexBuffer(3, ExtMapBuffer4); SetIndexStyle(3,DRAW_HISTOGRAM); SetIndexEmptyValue(3,0);
   SetIndexBuffer(4, ExtMapBuffer5); SetIndexStyle(4,DRAW_HISTOGRAM); SetIndexEmptyValue(4,0);
   SetIndexBuffer(5, ExtMapBuffer6); SetIndexStyle(5,DRAW_HISTOGRAM); SetIndexEmptyValue(5,0);
   SetIndexBuffer(6, ExtMapBuffer7); SetIndexStyle(6,DRAW_HISTOGRAM); SetIndexEmptyValue(6,0);
   SetIndexBuffer(7, ExtMapBuffer8); SetIndexStyle(7,DRAW_HISTOGRAM); SetIndexEmptyValue(7,0);
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            limit = MathMin(Bars-counted_bars,Bars-1);
            if (ArraySize(trend)!=Bars) ArrayResize(trend,Bars);
         
          
   //
   //
   //
   //
   //
   
   for(i=limit,r=Bars-limit-1; i >= 0; i--,r++)
   {
      double haOpen  = (ExtMapBuffer1[i+1]+ExtMapBuffer2[i+1]+ExtMapBuffer3[i+1]+ExtMapBuffer4[i+1])/2;
      double haClose = (Open[i]+High[i]+Low[i]+Close[i])/4;
      double haHigh  = MathMax(High[i], MathMax(haOpen, haClose));
      double haLow   = MathMin(Low[i] , MathMin(haOpen, haClose));   

      double acC = iAC(NULL,0,i); double acP = iAC(NULL,0,i+1); int acD = 0; if (acC>acP) acD=1; if (acC<acP) acD=2;
      double aoC = iAO(NULL,0,i); double aoP = iAO(NULL,0,i+1); int aoD = 0; if (aoC>aoP) aoD=1; if (aoC<aoP) aoD=2;
        
      //
      //
      //
      //
      //
      
      ExtMapBuffer1[i] = 0.0;
      ExtMapBuffer2[i] = 0.0;
      ExtMapBuffer3[i] = 0.0;
      ExtMapBuffer4[i] = 0.0;
      ExtMapBuffer5[i] = 0.0;
      ExtMapBuffer6[i] = 0.0;
      ExtMapBuffer7[i] = 0.0;
      ExtMapBuffer8[i] = 0.0;
      trend[r]         = trend[r-1];

      if(acD==1 && aoD==1)
      {
            if(haOpen>haClose) { ExtMapBuffer1[i] = haOpen;  ExtMapBuffer2[i] = haClose; }
            if(haOpen<haClose) { ExtMapBuffer1[i] = haClose; ExtMapBuffer2[i] = haOpen;  }
                                                             ExtMapBuffer5[i] = haHigh;
                                                             ExtMapBuffer6[i] = haLow;
            trend[r] = 1;
      } 
      if(acD==2 && aoD==2)
      {
            if(haOpen>haClose) { ExtMapBuffer1[i] = haClose; ExtMapBuffer2[i] = haOpen;  }
            if(haOpen<haClose) { ExtMapBuffer1[i] = haOpen;  ExtMapBuffer2[i] = haClose; }
                                                             ExtMapBuffer5[i] = haLow;
                                                             ExtMapBuffer6[i] = haHigh;
            trend[r] = 2;
      } 
      if(acD==1 && aoD==2)
      {
            if(haOpen>haClose) { ExtMapBuffer3[i] = haOpen;  ExtMapBuffer4[i] = haClose; }
            if(haOpen<haClose) { ExtMapBuffer3[i] = haClose; ExtMapBuffer4[i] = haOpen;  }
                                                             ExtMapBuffer7[i] = haHigh;
                                                             ExtMapBuffer8[i] = haLow;
            trend[r] = 3;
      } 
      if(acD==2 && aoD==1)
      {
            if(haOpen>haClose) { ExtMapBuffer3[i] = haClose; ExtMapBuffer4[i] = haOpen;  }
            if(haOpen<haClose) { ExtMapBuffer3[i] = haOpen;  ExtMapBuffer4[i] = haClose; }
                                                             ExtMapBuffer7[i] = haLow;
                                                             ExtMapBuffer8[i] = haHigh;
            trend[r] = 4;
      }
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = Bars-whichBar-1;

         //
         //
         //
         //
         //
         Comment(trend[whichBar],"  ",trend[whichBar-1]);
         if (trend[whichBar] != trend[whichBar-1])
            switch(trend[whichBar])
            {
               case 1 :  doAlert("up");      break;
               case 2 :  doAlert("down");    break;
               case 3 :  doAlert("neutral"); break;
               case 4 :  doAlert("neutral"); break;
            }               
   }

   //
   //
   //
   //
          
   return(0);
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," heiken ashi zone trade trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," heiken ashi zone trade "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

